<template>
  <div>
    <Ariane
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />
    <div v-if="shelfList" class="content">
      <template v-if="newestUniverses && newestUniverses.length">
        <UniverseListHeaderDesktop
          class="header-desktop"
          :title="$t('universeList.title')"
          :universes="newestUniverses"
        />
        <UniverseListHeaderMobile
          class="header-mobile"
          :title="$t('universeList.title')"
          :universes="newestUniverses"
        />
      </template>

      <div class="by-genres text--black">
        {{ $t('universeList.all_by_genres') }}
      </div>

      <UniverseTab :tab-list="shelfList" class="shelf-list" />
    </div>
    <Loader :display="isLoading" />
  </div>
</template>

<script>
import Ariane from '~/components/ui/Ariane'
import Loader from '~/components/ui/Loader'
import UniverseListHeaderDesktop from '~/components/UniverseList/UniverseListHeaderDesktop'
import UniverseListHeaderMobile from '~/components/UniverseList/UniverseListHeaderMobile'
import UniverseTab from '~/components/UniverseList/UniverseTab'

export default {
  name: 'Universe',
  components: {
    Ariane,
    Loader,
    UniverseListHeaderDesktop,
    UniverseListHeaderMobile,
    UniverseTab
  },

  async fetch() {
    await this.loadPage()
  },

  data() {
    return {
      title: this.$t('breadcrumb.universe'),
      breadcrumbs: [this.$t('breadcrumb.home'), this.$t('breadcrumb.universe')],
      params: [`/${this.$i18n.locale}/`, `/${this.$i18n.locale}/universe`],
      isLoading: true,
      shelfList: null,
      newestUniverses: []
    }
  },

  computed: {
    isAuthenticated() {
      return this.$auth.loggedIn
    },

    ui() {
      return this.$auth.loggedIn && this.$auth.user ? this.$auth.user : {}
    },

    isAboUser() {
      return 'hasActiveClassicSubscription' in this.ui
        ? this.ui.hasActiveClassicSubscription
        : false
    }
  },

  watch: {
    isAuthenticated() {
      //
    },

    ui() {
      //
    }
  },

  async mounted() {
    // refresh data for connected users (server data is prepared for guests only)
    // or reload if there is no data from SSR
    if (!this.newestUniverses.length || this.isAuthenticated) {
      await this.loadPage()
    }
  },

  methods: {
    async loadPage() {
      try {
        const home = this.$utils.aboArea()
          ? this.$utils.homeAboUrlForLang(this.$i18n.locale)
          : this.$utils.homeUrlForLang(this.$i18n.locale)

        const { items } = await this.$api.topUniverses(this.$utils.aboArea())
        if (!items || !items.length) {
          window.location.href = home
          return
        }

        const { shelves } = await this.$api.universeShelfList(
          this.$utils.aboArea()
        )
        if (!shelves || !shelves.length) {
          window.location.href = home
          return
        }

        this.shelfList = shelves
        this.newestUniverses = items

        this.title = `${this.$t('breadcrumb.universe')}`
      } finally {
        this.isLoading = false
      }
    }
  },

  head() {
    return {
      titleTemplate: this.title
    }
  }
}
</script>

<style lang="scss" scoped>
.content {
  padding: 0 20px;
  margin: auto;
  max-width: 1440px;

  @media (max-width: 768px) {
    padding: 0;
  }

  .by-genres {
    margin: 89px 0 65px;
    padding: 34px 69px 28px;
    background: $color-grey;
    font-family: DINCond-Bold;
    font-weight: bold;
    font-size: 36px;

    @media (max-width: 768px) {
      margin: 40px 0 16px;
      padding: 24px 22px;
      font-size: 24px;
    }
  }

  .shelf-list {
    margin: auto;
    max-width: 1440px;
    padding: 0 70px;

    @media (max-width: 768px) {
      padding: 0 15px;
    }
  }
}

.header-mobile {
  display: none;
}

.header-desktop {
  display: block;
}

@media (max-width: 768px) {
  .header-mobile {
    display: block;
  }

  .header-desktop {
    display: none;
  }
}
</style>
